import { IAttributeChangeOptions, IAttributeSetReturn, IAttributeFactory, AttributesBase } from '@pilotlab/data';
import { List, MapList, Stack } from '@pilotlab/collections';
import { Signal } from '@pilotlab/signals';
import Message from './message';
import StateFactory from './stateFactory';
import StateBase from './stateBase';
import IStates from './interfaces/iStates';
export declare abstract class StatesBase<TState extends StateBase<any>> extends AttributesBase<TState, StatesBase<TState>> implements IStates {
    protected constructor(factory?: IAttributeFactory, parent?: TState, pathSegment?: string);
    readonly create: StateFactory;
    protected p_factory: StateFactory;
    internalCurrentPrincipalIndex: number;
    protected p_mapPrincipal: MapList<string, any>;
    protected p_skipOnPrevious: List<string>;
    protected p_lastState: TState;
    readonly active: Stack<TState>;
    protected p_active: Stack<TState>;
    readonly previous: TState;
    protected p_previousState: TState;
    readonly current: TState;
    readonly pathPrevious: string;
    protected p_pathPrevious: string;
    readonly pathLast: string;
    protected p_pathLast: string;
    resetCompleted: Signal<any>;
    entered: Signal<TState>;
    exited: Signal<TState>;
    message: Signal<Message>;
    reset(baseStateName?: string, value?: any): this;
    protected p_onReset(value?: any): void;
    isCurrent(name: string): boolean;
    add(state: TState, index?: number, changeOptions?: IAttributeChangeOptions): TState;
    set(path: string, value?: any, label?: string): IAttributeSetReturn;
    addPrincipal(path: string, value?: any, isSkipOnPrevious?: boolean): IAttributeSetReturn;
    removePrincipal(path: string): TState;
    isPrincipal(path: string): boolean;
    getPrincipalIndex(path: string): number;
    goFirst(value?: any, changeOptions?: IAttributeChangeOptions): TState;
    goNext(value?: any, changeOptions?: IAttributeChangeOptions, isCycle?: boolean): TState;
    goPrevious(value?: any, changeOptions?: IAttributeChangeOptions, isCycle?: boolean): TState;
    goLast(value?: any, changeOptions?: IAttributeChangeOptions): TState;
    internalPush(state: TState, value: any, changeOptions: IAttributeChangeOptions, isEnter?: boolean, isExitPrevious?: boolean, isPopAllActiveStates?: boolean): this;
    protected p_pushPath(path: string, value: any, changeOptions: IAttributeChangeOptions, isEnter: boolean, isExitPrev: boolean, isPopAll: boolean): TState;
    internalPushSegment(segment: string, value: any, changeOptions: IAttributeChangeOptions, isEnter: boolean, isExitPrev: boolean, isPopAll: boolean): TState;
    enter(path: string, value?: any, changeOptions?: IAttributeChangeOptions): TState;
    push(path: string, value?: any, changeOptions?: IAttributeChangeOptions, isEnter?: boolean, isExitPrev?: boolean, isPopAll?: boolean): TState;
    exitCurrent(changeOptions?: IAttributeChangeOptions): this;
    pop(changeOptions?: IAttributeChangeOptions, isExit?: boolean, isEnterPrevious?: boolean): this;
    popAllAbove(state: (TState | string), changeOptions?: IAttributeChangeOptions, isExitEach?: boolean, isEnter?: boolean): this;
    exit(state: (TState | string), changeOptions?: IAttributeChangeOptions): this;
    popAllAboveInclusive(state: (TState | string), changeOptions?: IAttributeChangeOptions, isExitEach?: boolean, isEnterPrev?: boolean): this;
    popAll(isExitEach?: boolean, changeOptions?: IAttributeChangeOptions): this;
    swap(state: (TState | string), value?: any, changeOptions?: IAttributeChangeOptions, isExitCurrent?: boolean): this;
    get(path: string): TState;
    broadcastMessage(message: string, data?: any): StatesBase<TState>;
}
export default StatesBase;
